%define anolis_release 1
%undefine __cmake_in_source_build

Name:           leveldb
Version:        1.23
Release:        %{anolis_release}%{?dist}
Summary:        A fast and lightweight key/value database library by Google
License:        BSD
URL:            https://github.com/google/leveldb
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

# -fno-rtti breaks ABI compatibility
Patch0006:      0006-revert-no-rtti.patch

BuildRequires:  cmake make gcc gcc-c++
BuildRequires:  snappy-devel sqlite-devel

%description
LevelDB is a fast key-value storage library written at Google that provides an
ordered mapping from string keys to string values.

%package devel
Summary:        Development files for %{name}
Requires:       cmake-filesystem
Requires:       %{name} = %{EVR}

%description devel
%{summary}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

cat > %{name}.pc << EOF
prefix=%{_prefix}
exec_prefix=${prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: %{name}
Description: %{summary}
Version: %{version}
Libs: -l%{name}
EOF

%build
%cmake -DLEVELDB_BUILD_TESTS:BOOL=OFF \
       -DLEVELDB_BUILD_BENCHMARKS:BOOL=OFF
%cmake_build

%install
%cmake_install

mkdir -p %{buildroot}%{_libdir}/pkgconfig
cp -a %{name}.pc %{buildroot}%{_libdir}/pkgconfig/

%generate_compatibility_deps

%check
%ctest

%files
%license LICENSE
%{_libdir}/lib%{name}.so.*
%dir %{abidir}
%{abidir}/libleveldb.dump

%files devel
%doc doc/ CONTRIBUTING.md TODO
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/cmake/%{name}/

%files doc
%doc AUTHORS README.md NEWS

%changelog
* Thu Jun 8 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.23-1
- Init from upstream
